<?php

namespace Askaron\Ibvote;

use Bitrix\Main\ORM;
use Bitrix\Main\Entity;
use Bitrix\Main\Type;
//use Bitrix\Main\Localization\Loc;
//Loc::loadMessages(__FILE__);

//class_alias('Bitrix\Main\ORM\Data\DataManager', 'Bitrix\Main\Entity\DataManager');
//class EventTable extends \Bitrix\Main\Entity\DataManager

//'ID' => new ORM\Fields\IntegerField(
//	'ID',
//	[
//		'primary' => true,
//		'autocomplete' => true,
//		'title' => Loc::getMessage('ELEMENT_ENTITY_ID_FIELD'),
//	]
//),

class EventTable extends \Bitrix\Main\ORM\Data\DataManager
{
	public static function getTableName()
	{
		return 'b_askaron_ibvote_event';
	}

	public static function getMap()
	{
		//global $DB;
		//new Bitrix\Main\Entity\IntegerField;

		//create table if not exists b_askaron_ibvote_event (
		//	ID int(18) not null auto_increment,
		//	ELEMENT_ID int(18) not null default '0',
		//	ANSWER int(18),
		//	DATE_VOTE datetime not null default '0000-00-00 00:00:00',
		//	IP varchar(15),
		//	USER_ID int(18),
		//	STAT_SESSION_ID int(18),
		//	primary key (ID),
		//	index IX_ELEMENT_ID_IP (ELEMENT_ID,IP),
		//	index IX_ELEMENT_ID_USER_ID (ELEMENT_ID,USER_ID)
		//);


		$fieldsMap = array(
			new ORM\Fields\IntegerField('ID', array(
				'primary' => true,
				'autocomplete' => true,
			)),
			new ORM\Fields\IntegerField('ELEMENT_ID', array(
				'required' => true,
			)),
//			class_alias('Bitrix\Main\ORM\Fields\Relations\Reference', 'Bitrix\Main\Entity\ReferenceField');
//			new Entity\ReferenceField('ELEMENT'),

			new ORM\Fields\Relations\Reference('ELEMENT',
				'\Bitrix\Iblock\Element',
				array('=this.ELEMENT_ID' => 'ref.ID')
//				,
//				[
//					'join_type' => 'LEFT',
//				]
			),
			new ORM\Fields\IntegerField('ANSWER', array(
				'nullable' => true,
			)),

			// class_alias('Bitrix\Main\ORM\Fields\DatetimeField', 'Bitrix\Main\Entity\DatetimeField');
			new ORM\Fields\DatetimeField( 'DATE_VOTE', array(
				'required' => true,
			)),
			new ORM\Fields\StringField('IP', array(
					'nullable' => true,
				)
			),
			new ORM\Fields\IntegerField('USER_ID', array(
				'nullable' => true,
			)),
//			'USER' => array(
//				'data_type' => '',
//				'reference' => array('=this.USER_ID' => 'ref.ID'),
//			),
			new ORM\Fields\Relations\Reference('USER',
				'\Bitrix\Main\User',
				array('=this.USER_ID' => 'ref.ID')
//				,
//				[
//					'join_type' => 'LEFT',
//				]
			),

//			'CREATED_BY_USER' => new ORM\Fields\Relations\Reference(
//				'CREATED_BY_USER',
//				'\Bitrix\Main\User',
//				['=this.CREATED_BY' => 'ref.ID'],
//				['join_type' => 'LEFT'],
//			),


			new ORM\Fields\IntegerField('STAT_SESSION_ID', array(
				'nullable' => true,
			)),
		);

		return $fieldsMap;
	}


	/**
	 * Add element.
	 *
	 * @param array $data			Element data.
	 * @return ORM\Data\AddResult
	 */
	public static function add(array $data): ORM\Data\AddResult
	{
		$result = new ORM\Data\AddResult();
		$result->addError(new ORM\EntityError(
			'ELEMENT_ENTITY_ADD_BLOCKED'
		));

		return $result;
	}

	/**
	 * Updates element by primary key.
	 *
	 * @param mixed $primary		Element primary key.
	 * @param array $data			Element data.
	 * @return ORM\Data\UpdateResult
	 */
	public static function update($primary, array $data): ORM\Data\UpdateResult
	{
		$result = new ORM\Data\UpdateResult();
		$result->addError(new ORM\EntityError(
			'ELEMENT_ENTITY_UPDATE_BLOCKED'
		));

		return $result;
	}

	/**
	 * Deletes element by primary key.
	 *
	 * @param mixed $primary		Element primary key.
	 * @return ORM\Data\DeleteResult
	 */
	public static function delete($primary): ORM\Data\DeleteResult
	{
		$result = new ORM\Data\DeleteResult();
		$result->addError(new ORM\EntityError(
			'ELEMENT_ENTITY_DELETE_BLOCKED'
		));

		return $result;
	}
}

